//----------------------------------------------------------------------------------
// XbhNX
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#pragma once

typedef void (__cdecl * THRPROCFUNC)(void *);

class ThrProc
{
private:
	CRITICAL_SECTION m_cs;
	HANDLE m_hReq, m_hFin;
	HANDLE m_hThr;
	unsigned int m_idThr;
	int m_priThr;
	volatile bool m_stop;

	bool m_req;
	void *m_param;
	THRPROCFUNC m_func;

public:
	ThrProc();
	~ThrProc();

	int Init(THRPROCFUNC fn, void *param);
	int Start();
	int Wait();
	int Shutdown();

	bool isRunning() const { return m_req; }

private:
	void CloseEvent();
	void Proc();
	static unsigned int __stdcall IniProc(void *param);
};
